$typecheck on
$escapechars on
$option icon "codeEdit.ico"
'
Const crlf = CHR$(13) + CHR$(10)
' The following lines enable BOOL variable type usage
$Define Bool Integer
CONST True = 1
CONST False = 0
CONST fmCreate = 65535

$include "Win32_constants.inc"
$include "CM_Constants.inc"
$include "CM_Functions.inc"
$include "QAbout.inc"


Const White = 16777215
Const Black = 0
Const Blue = 16711680
Const Red = 255
CONST alBottom = 2

Const FILE_BEGIN = 0
Const GENERIC_WRITE = &H40000000
Const GENERIC_READ = &H80000000
Const OPEN_EXISTING = 3
Const FILE_SHARE_READ = &H1
Const FILE_SHARE_WRITE = &H2
Const WM_CLEAR = &H303

$RESOURCE New_BMP AS "New.bmp"
$RESOURCE Open_BMP AS "Open.bmp"
$RESOURCE Save_BMP AS "Save.bmp"
$RESOURCE Print_BMP AS "Print.bmp"
$RESOURCE Undo_BMP AS "Undo.bmp"
$RESOURCE Redo_BMP AS "Redo.bmp"
$RESOURCE Cut_BMP AS "Cut.bmp"
$RESOURCE Copy_BMP AS "Copy.bmp"
$RESOURCE Paste_BMP AS "Paste.bmp"
$RESOURCE Selectall_BMP AS "SelectAll.bmp"
$RESOURCE Delete_BMP AS "Delete.bmp"
$RESOURCE Find_BMP AS "Find.bmp"
$RESOURCE Replace_BMP AS "Replace.bmp"
$RESOURCE Compile_BMP AS "Compile.bmp"
$RESOURCE Run_BMP AS "Run.bmp"
$RESOURCE About_BMP AS "About.bmp"
$RESOURCE Exit_BMP AS "Exit.bmp"

Dim apii as long
Dim apiout as long
dim winhandle as long
DIM Compiled AS INTEGER
Compiled = 0
DIM SourceFile2 as String
SourceFile2 = "Noname.bas"
DIM OD AS QOPENDIALOG
DIM SD AS QSAVEDIALOG
DIM About2 AS QAbout


Declare Function WaitForSingleObject Lib "kernel32" Alias "WaitForSingleObject" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long


DECLARE FUNCTION CreateWindowEx LIB "USER32" ALIAS "CreateWindowExA" _
                 (ExStyle&, ClassName$, WindowName$, Style&, X&, Y&, _
                  Width&, Height&, WndParent&, hMenu&, hInstance&, Param&) AS LONG


DECLARE FUNCTION GetModuleHandle LIB "KERNEL32" ALIAS "GetModuleHandleA" _
                 (ModuleName AS STRING) AS LONG

Declare Function DestroyWindow Lib "user32" Alias "DestroyWindow" _
(ByVal hwnd As Long) As Long

Declare Function SetParent Lib "user32" Alias "SetParent" _
(ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long

Declare Function FlashWindow Lib "user32" Alias "FlashWindow" _
(ByVal hwnd As Long, ByVal bInvert As Long) As Long

Declare Function ShowWindow Lib "user32" Alias "ShowWindow" _
(ByVal hwnd As Long, ByVal nCmdShow As Long) As Long

Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" _
(ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Declare sub showwin
Declare sub chiudi
declare sub resize
DECLARE SUB TimeUpdate
DECLARE SUB New_Click
DECLARE SUB Open_Click
DECLARE SUB Save_Click
DECLARE SUB SaveAs_Click
DECLARE SUB Compile_Click
DECLARE SUB Run_Click
DECLARE SUB CompOk_Click
DECLARE SUB Print_Click
DECLARE SUB Exit_Click
DECLARE SUB Undo_Click
DECLARE SUB Redo_Click
DECLARE SUB Cut_Click
DECLARE SUB Copy_Click
DECLARE SUB Paste_Click
DECLARE SUB SelectAll_Click
DECLARE SUB Delete_Click
DECLARE SUB Find_Click
DECLARE SUB Replace_Click
DECLARE SUB About_Click
DECLARE SUB Show_Hint (Hint AS String)
DECLARE SUB Capital_Click
DECLARE SUB Upper_Click
DECLARE SUB Lower_Click

DIM Timer1 AS QTIMER
With Timer1
  .Interval = 100
  .OnTimer = TimeUpdate
End With

Dim CodeEdit as qform
With CodeEdit
.caption = "Code Edit" & CHR$(32) & SourceFile2
.center
.delBorderIcons(2)
.Height = 600
.Width = 800
.onhint = Show_Hint
.onshow = Showwin
End with

Dim CompForm AS QFORM
With CompForm
  .BorderStyle = 0
  .Height = 125
  .Parent = CodeEdit
  .Width = 300
  .Center
End With

Dim CompRich AS QRICHEDIT
With CompRich
  .Align = 1
  .Font.Name = "Courier"
  .Font.Size = 8
  .Font.Color = = &HFF0000
  .Height = CompForm.ClientHeight - 25
  .Parent = CompForm
  .Plaintext = 1
  .ScrollBars = 3
  .Visible = 1
End With

Dim CompOk AS QBUTTON
With CompOk 
  .Kind = 2
  .OnClick = CompOk_Click
  .Parent = CompForm
  .Top = CompForm.ClientHeight - 25
  .Width = 75
End With

CREATE MainMenu AS QMAINMENU
  Parent = CodeEdit
  CREATE mnuFile AS QMENUITEM
    Caption = "&File"
    Checked = 0
    Enabled = 1
    Visible = 1
    CREATE mnuNew AS QMENUITEM
      Caption = "&New"
      Checked = 0
      Enabled = 1
      Hint = "New Document"
      OnClick = new_Click
      Visible = 1
      ShortCut = "CTRL+N"
    END CREATE
    CREATE mnuOpen AS QMENUITEM
      Caption = "&Open"
      Checked = 0
      Enabled = 1
      Hint = "Open Document"
      OnClick = Open_Click
      Visible = 1
      ShortCut = "CTRL+O"
    END CREATE
    CREATE mnuSave AS QMENUITEM
      Caption = "&Save"
      Checked = 0
      Enabled = 1
      Hint = "Save document"
      OnClick = Save_Click
      Visible = 1
      ShortCut = "CTRL+S"
    END CREATE
    CREATE mnuSaveAs AS QMENUITEM
      Caption = "SaveAs"
      Checked = 0
      Enabled = 1
      Hint = "Save document with prompt"
      OnClick = SaveAs_Click
      Visible = 1
    END CREATE
    CREATE mnuPrint AS QMENUITEM
      Caption = "&Print"
      Checked = 0
      Enabled = 1
      Hint = "Print the current document"
      OnClick = Print_Click
      Visible = 1
      ShortCut = "CTRL+P"
    END CREATE
    CREATE mnuExit AS QMENUITEM
      Caption = "&Exit"
      Checked = 0
      Enabled = 1
      Hint = "Exit the program"
      OnClick = Exit_Click
      Visible = 1
      ShortCut = "ALT+F4"
    END CREATE
  END CREATE
  CREATE mnuEdit AS QMENUITEM
    Caption = "&Edit"
    Checked = 0
    Enabled = 1
    Visible = 1
    CREATE mnuUndo AS QMENUITEM
      Caption = "&Undo"
      Checked = 0
      Enabled = 1
      Hint = "Undo last modification"
      OnClick = Undo_Click
      Visible = 1
      ShortCut = "CTRL+Z"
    END CREATE
    CREATE mnuRedo AS QMENUITEM
      Caption = "&Redo"
      Checked = 0
      Enabled = 1
      Hint = "Revert Undo actions"
      OnClick = Redo_Click
      Visible = 1
    END CREATE
    CREATE EditBar0 AS QMENUITEM
      Caption = "-"
      Checked = 0
      Enabled = 1
      Visible = 1
    END CREATE
    CREATE mnuCut AS QMENUITEM
      Caption = "&Cut"
      Checked = 0
      Enabled = 1
      Hint = "Cut selected text"
      OnClick = Cut_Click
      Visible = 1
      ShortCut = "CTRL+X"
    END CREATE
    CREATE mnuCopy AS QMENUITEM
      Caption = "C&opy"
      Checked = 0
      Enabled = 1
      Hint = "Copy selected text"
      OnClick = Copy_Click
      Visible = 1
      ShortCut = "CTRL+C"
    END CREATE
    CREATE mnuPaste AS QMENUITEM
      Caption = "&Paste"
      Checked = 0
      Enabled = 1
      Hint = "Paste text"
      OnClick = Paste_Click
      Visible = 1
      ShortCut = "CTRL+V"
    END CREATE
    CREATE EditBar1 AS QMENUITEM
      Caption = "-"
      Checked = 0
      Enabled = 1
      Visible = 1
    END CREATE
    CREATE mnuSelectAll AS QMENUITEM
      Caption = "&SelectAll"
      Checked = 0
      Enabled = 1
      Hint = "Select all text"
      OnClick = SelectAll_Click
      Visible = 1
      ShortCut = "CTRL+A"
    END CREATE
    CREATE mnuDelete AS QMENUITEM
      Caption = "&Delete"
      Checked = 0
      Enabled = 1
      Hint = "Delete selected text"
      OnClick = Delete_Click
      Visible = 1
      ShortCut = "DEL"
    END CREATE
    CREATE EditBar2 AS QMENUITEM
      Caption = "-"
      Checked = 0
      Enabled = 1
      Visible = 1
    END CREATE
    CREATE mnuLower AS QMENUITEM
      Caption = "&Lower Case"
      Checked = 0
      Enabled = 1
      Hint = "Convert to Lower"
      OnClick = Lower_Click
      Visible = 1
    END CREATE
    CREATE mnuUpper AS QMENUITEM
      Caption = "&Upper Case"
      Checked = 0
      Enabled = 1
      Hint = "Convert to Upper"
      OnClick = Upper_Click
      Visible = 1
    END CREATE
    CREATE mnuCapitalize AS QMENUITEM
      Caption = "Capitalize"
      Checked = 0
      Enabled = 1
      Hint = "Capitalize"
      OnClick = Capital_Click
      Visible = 1
    END CREATE
  END CREATE 
  CREATE mnuFind AS QMENUITEM
    Caption = "Find/&Replace"
    Checked = 0
    Enabled = 1
    Visible = 1
    CREATE mnuFindit AS QMENUITEM
      Caption = "&Find"
      Checked = 0
      Enabled = 1
      Hint = "Find text"
      OnClick = Find_Click
      Visible = 1
      ShortCut = "CTRL+F"
    END CREATE
    CREATE mnuReplace AS QMENUITEM
      Caption = "&Replace"
      Checked = 0
      Enabled = 1
      Hint = "Find and Replace text"
      OnClick = Replace_Click
      Visible = 1
      ShortCut = "CTRL+R"
    END CREATE
  END CREATE
  CREATE mnuCompile AS QMENUITEM
    Caption = "&Compile"
    Checked = 0
    Enabled = 1
    Visible = 1
    CREATE mnuCompileit AS QMENUITEM
      Caption = "&Compile"
      Checked = 0
      Enabled = 1
      Hint = "Compile"
      OnClick = Compile_Click
      Visible = 1
      ShortCut = "F5"
    END CREATE
    CREATE mnuRun AS QMENUITEM
      Caption = "Compile and &Run"
      Checked = 0
      Enabled = 1
      Hint = "Compile and Run"
      OnClick = Run_Click
      Visible = 1
      ShortCut = "CTRL+F5"
    END CREATE
  END CREATE 
  CREATE mnuAbout AS QMENUITEM
    Caption = "&About"
    Checked = 0
    Enabled = 1
    Hint = "About CodeEdit"
    OnClick = About_Click
    Visible = 1
  END CREATE
END CREATE

CodeEdit.onresize = resize
CodeEdit.onclose = chiudi
CodeEdit.showmodal


sub showwin
' Component Registration
apii = CmUnregister()
apii = CMRegister(CM_VERSION)

' Creating editor window
winhandle = CreateWindowEx(0, _
    "CodeSense", "", WS_VISIBLE OR WS_CHILD, _
    0, 35, 790, 497, CodeEdit.handle, _
    0, GetModuleHandle(command$(0)), 0)
ShowWindow(winhandle, 3)

DIM Status AS QSTATUSBAR
With Status
  .Align = alBottom
  .AddPanels "",""
  .Panel(0).Width = 125
  .Panel(0).Caption = Date$ & CHR$(32) & Time$
  .Panel(1).Caption = "Based upon CodeSense.bas created by _
  Dreadsoft Corporation dreadsoft@yahoo.it"
  .Parent = CodeEdit
  .Visible = 1
End with

SUB TimeUpdate
  Status.Panel(0).Caption = Date$ & CHR$(32) & Time$
END SUB

SUB Show_Hint
  Status.Panel(1).Caption = Hint
END SUB

DIM Toolbar AS QPANEL
With Toolbar
  .Align = 1
  .BevelInner = 2
  .BevelOuter = 2
  .BorderStyle = 1
  .Height = 35
  .Parent = CodeEdit
End With

DIM cmdExit AS QCOOLBTN
With cmdExit
  .Align = 3
  .BMPHandle = Exit_BMP
  .Flat = 1
  .Hint = "Exit"
  .OnClick = Exit_Click
  .Parent = Toolbar
  .ShowHint = 1
End With

DIM cmdAbout AS QCOOLBTN
With cmdAbout
  .Align = 3
  .BMPHandle = About_BMP
  .Flat = 1
  .Hint = "About"
  .OnClick = About_Click
  .Parent = Toolbar
  .ShowHint = 1
End With

DIM cmdRun AS QCOOLBTN
With cmdRun
  .Align = 3
  .BMPHandle = Run_BMP
  .Flat = 1
  .Hint = "Compile and Run"
  .OnClick = Run_Click
  .Parent = Toolbar
  .ShowHint = 1
End With

DIM cmdCompile AS QCOOLBTN
With cmdCompile
  .Align = 3
  .BMPHandle = Compile_BMP
  .Flat = 1
  .Hint = "Compile"
  .OnClick = Compile_Click
  .Parent = Toolbar
  .ShowHint = 1
End With

DIM Bar1 AS QCOOLBTN
With Bar1
  .Align = 3
  .Enabled = 0
  .Parent = Toolbar
  .Visible = 1
  .Width = 3
End With

DIM cmdReplace AS QCOOLBTN
With cmdReplace
  .Align = 3
  .BMPHandle = Replace_BMP
  .Flat = 1
  .Hint = "Replace"
  .OnClick = Replace_Click
  .Parent = Toolbar
  .ShowHint = 1
End With

DIM cmdFind AS QCOOLBTN
With cmdFind
  .Align = 3
  .BMPHandle = Find_BMP
  .Flat = 1
  .Hint = "Find"
  .OnClick = Find_Click
  .Parent = Toolbar
  .ShowHint = 1
End With

DIM cmdDelete AS QCOOLBTN
With cmdDelete
  .Align = 3
  .BMPHandle = Delete_BMP
  .Flat = 1
  .Hint = "Delete"
  .OnClick = Delete_Click
  .Parent = Toolbar
  .ShowHint = 1
End With

DIM cmdSelectAll AS QCOOLBTN
With cmdSelectAll
  .Align = 3
  .BMPHandle = SelectAll_BMP
  .Flat = 1
  .Hint = "SelectAll"
  .OnClick = SelectAll_Click
  .Parent = Toolbar
  .ShowHint = 1
End With

DIM cmdPaste AS QCOOLBTN
With cmdPaste
  .Align = 3
  .BMPHandle = Paste_BMP
  .Flat = 1
  .Hint = "Paste"
  .OnClick = Paste_Click
  .Parent = Toolbar
  .ShowHint = 1
End With

DIM cmdCopy AS QCOOLBTN
With cmdCopy
  .Align = 3
  .BMPHandle = Copy_BMP
  .Flat = 1
  .Hint = "Copy"
  .OnClick = Copy_Click
  .Parent = Toolbar
  .ShowHint = 1
End With

DIM cmdCut AS QCOOLBTN
With cmdCut
  .Align = 3
  .BMPHandle = Cut_BMP
  .Flat = 1
  .Hint = "Cut"
  .OnClick = Cut_Click
  .Parent = Toolbar
  .ShowHint = 1
End With

DIM cmdRedo AS QCOOLBTN
With cmdRedo
  .Align = 3
  .BMPHandle = Redo_BMP
  .Flat = 1
  .Hint = "Redo"
  .OnClick = Redo_Click
  .Parent = Toolbar
  .ShowHint = 1
End With

DIM cmdUndo AS QCOOLBTN
With cmdUndo
  .Align = 3
  .BMPHandle = Undo_BMP
  .Flat = 1
  .Hint = "Undo"
  .OnClick = Undo_Click
  .Parent = Toolbar
  .ShowHint = 1
End With

DIM Bar0 AS QCOOLBTN
With Bar0
  .Align = 3
  .Enabled = 0
  .Parent = Toolbar
  .Visible = 1
  .Width = 3
End With

DIM cmdPrint AS QCOOLBTN
With cmdPrint
  .Align = 3
  .BMPHandle = Print_BMP
  .Flat = 1
  .Hint = "Print"
  .OnClick = Print_Click
  .Parent = Toolbar
  .ShowHint = 1
End With

DIM cmdSave AS QCOOLBTN
With cmdSave
  .Align = 3
  .BMPHandle = Save_BMP
  .Flat = 1
  .Hint = "Save"
  .OnClick = Save_Click
  .Parent = Toolbar
  .ShowHint = 1
End With

DIM cmdOpen AS QCOOLBTN
With cmdOpen
  .Align = 3
  .BMPHandle = Open_BMP
  .Flat = 1
  .Hint = "Open"
  .OnClick = Open_Click
  .Parent = Toolbar
  .ShowHint = 1
End With

DIM cmdNew AS QCOOLBTN
With cmdNew
  .Align = 3
  .BMPHandle = New_BMP
  .Flat = 1
  .Hint = "New"
  .OnClick = New_Click
  .Parent = Toolbar
  .ShowHint = 1
End With



' Setting up the language and syntax highlighting
Dim language as string
RegisterRapidQLanguage
Cm_SetLanguage (winhandle, "RapidQ")
CM_EnableLeftMargin(winhandle, False)
CM_EnableColorSyntax (winhandle, 1)
CM_EnableColumnSel (winhandle, 1)
CM_SetBorderStyle (winhandle, 1)
CM_EnableHideSel (winhandle, 0)

Dim ColorSet as CM_Colors
With Colorset
     .crWindow = White
     .crLeftMargin = 14079702
     .crBookmark = 0
     .crBookmarkBk = 0
     .crText = Black
     .crTextBk = -1
     .crNumber = Red
     .crNumberBk = White
     .crKeyword =  Blue
     .crKeywordBk = -1
     .crOperator = Red
     .crOperatorBk = White
     .crScopeKeyword = Red
     .crScopeKeywordBk = White
     .crComment = 11447982
     .crCommentBk = White
     .crString = 8421440
     .crStringBk = White
     .crTagText = 256
     .crTagTextBk = White
     .crTagEntity = 256
     .crTagEntityBk = White
     .crTagElementName = 256
     .crTagElementNameBk = White
     .crTagAttributeName = 256
     .crTagAttributeNameBk = White
     .crLineNumber = Black
     .crLineNumberBk = .crLeftMargin
     .crHDividerLines = 8421440
     .crVDividerLines = 256
     .crHighlightedLine = 256
End with
Cm_SetColors(winhandle, ColorSet)


Dim Fonts as CM_FONTSTYLES
With Fonts
.byText = 0               ' plain text font style
.byNumber = 0             ' numeric literal font style
.byKeyword = 1            ' keyword font style
.byOperator = 1           ' operator font style
.byScopeKeyword = 4       ' scope keyword font style
.byComment = 2            ' comment font style
.byString = 2             ' string font style
.byTagText = 0            ' plain tag text font style
.byTagEntity = 0          ' tag entity font style
.byTagElementName = 0     ' tag element name font style
.byTagAttributeName = 0   ' tag attribute name font style
.byLineNumber = 0         ' line number font style
end With
Cm_SetFontStyles (winhandle, Fonts)

Dim LineNum as CM_LINENUMBERING
With linenum
    .bEnabled = True
    .nStartAt = 1
    .dwStyle = CM_DECIMAL
End with

Cm_SetLineNumbering(winhandle, Linenum)
CM_ShowScrollBar(winhandle, 0, 1)
CM_ShowScrollBar(winhandle, 1, 1)
End sub


Sub chiudi
apii = CmUnregister
DestroyWindow(winhandle)
End sub

Sub resize
Setparent(winhandle, CodeEdit.handle)
ShowWindow(winhandle, 0)
ShowWindow(winhandle, 1)
End sub

SUB New_Click
  SetFocus (winhandle)
  CM_SetSelect (winhandle)
  CM_SelectAll (winhandle)
  CM_Delete (winhandle)
  SourceFile2 = "Noname.bas"
  CodeEdit.caption = "Code Edit" & CHR$(32) & SourceFile2  
  Compiled = 0
END SUB
  
SUB Open_Click 
  OD.Filter = "Basic Files (*.bas)|*.bas"
  IF OD.Execute Then
    SourceFile2 = OD.Filename
  END IF
  CM_OpenFile(winhandle, SourceFile2)
  SetFocus (winhandle)
  CodeEdit.caption = "Code Edit" & CHR$(32) & SourceFile2  
  Compiled = 0
END SUB

SUB Save_Click
  IF SourceFile2 = "Noname.bas" Then SaveAs_Click
  CM_SaveFile (winhandle, 1, CurDir$ + SourceFile2)
END SUB

SUB SaveAs_Click
  SD.Filter = "Basic Files (*.bas)|*.bas"
  IF SD.Execute Then
    SourceFile2 = SD.Filename
  END IF
  CM_SaveFileAs (winhandle, SourceFile2)
  CodeEdit.caption = "Code Edit" & CHR$(32) & SourceFile2
  Compiled = 0
END SUB

SUB Compile_Click
  DIM Compiler AS STRING
  DIM Icon AS STRING
  DIM PID AS long
  DIM Path AS STRING
  Path = COMMAND$(0)-Application.ExeName
  CompForm.Visible = 1
  IF SourceFile2 <> "" THEN
    Compiler = "\"" + Path + "RC.EXE\" -vON -r " '& SourceFile2
    Compiler = Compiler + "-I\"" + Path + "\Include\" -L\"" + Path + "\Lib\" \"" + SourceFile2 + "\""
    PID = SHELL(Compiler,0)
    WaitForSingleObject (PID, &HFFFF)
    Path = SplitPath(SourceFile2)
    CompRich.LoadFromFile Path + "DUMP.$$$"
    Kill Path + "DUMP.$$$"
  END IF
  Compiled = 1
END SUB

SUB Run_Click
  IF Compiled = 0 Then 
    Compile_Click
    CompForm.Visible = 0
  END IF
  DIM exename AS STRING
  DIM retval AS LONG
  ExeName =REPLACE$( SourceFile2,".exe",LEN(SourceFile2)-3)
  retval = SHELL(ExeName , 1)
END SUB

SUB CompOk_Click
  CompForm.Visible = 0
END SUB

SUB Print_Click
  CM_Print (winhandle, 1,)
END SUB

SUB Exit_Click
  CodeEdit.Close
END SUB

SUB Undo_Click
  CM_Undo (winhandle)
END SUB

SUB Redo_Click
  CM_Redo (winhandle)
END SUB

SUB Cut_Click
  CM_Cut (winhandle)
END SUB

SUB Copy_Click
  CM_Copy (winhandle)
END SUB

SUB Paste_Click
  CM_Paste (winhandle)
END SUB

SUB SelectAll_Click
  CM_SelectAll (winhandle)
END SUB

SUB Delete_Click
  CM_Delete (winhandle)
END SUB

SUB Lower_Click
  CM_Lower(winhandle)
END SUB

SUB Upper_Click
  CM_Upper(winhandle)
END SUB
  
SUB Capital_Click
  CM_Capitalize(winhandle)
END SUB

SUB Find_Click
  CMC_Find (winhandle)
END SUB

SUB Replace_Click
  CMC_FindReplace (winhandle)
END SUB

SUB About_Click
  About2.Appname = "Code Edit"
  About2.AppFont.Name = "Engravers MT"
  About2.AppFont.color = 4194304
  About2.AppFont.Bold = 1
  About2.AppFont.Size = 12
  About2.Appversion = "0.1"
  About2.Email = "danny_307mo@lycos.com"
  About2.Text = CHR$(13) + "Created by Danny Jackson" + CHR$(13) + CHR$(13) + "With special thanks to my good friend: Dreadsoft Corporation (manco un diritto riservato) dreadsoft@yahoo.it" _
  + CHR$(13) + "Without whoose help and friendship this program would not have happened" _
  + CHR$(13)
  About2.Show
END SUB